'use strict'

const path = require('path')
require('app-module-path').addPath(path.resolve(__dirname, 'lib-gen'))

const SetBenchmark = require('SetBenchmark')
const ListBenchmark = require('ListBenchmark')

module.exports = {
  set: {
    constructors: {
      nativeArray (array) {
        return SetBenchmark.nativeArrayConstructor(array)
      },
      empty () {
        return SetBenchmark.emptyConstructor
      }
    },
    conversions: {
      nativeArray (me) {
        return SetBenchmark.nativeArrayConversion(me)
      }
    },
    modifications: {
      add (me, item) {
        return SetBenchmark.addModification(item)(me)
      },
      delete (me, item) {
        return SetBenchmark.deleteModification(item)(me)
      },
      union (me, other) {
        return SetBenchmark.unionModification(me)(other)
      },
      intersect (me, other) {
        return SetBenchmark.intersectModification(me)(other)
      },
      difference (me, other) {
        return SetBenchmark.differenceModification(me)(other)
      }
    },
    searches: {
      member (me, item) {
        return SetBenchmark.memberSearch(item)(me)
      }
    },
    comparisons: {
      equals (me, other) {
        return SetBenchmark.equalsComparison(me)(other)
      },
      subsetOf (me, other) {
        return SetBenchmark.subsetOfComparison(other)(me)
      }
    }
  },
  list: {
    constructors: {
      nativeArray (array) {
        return ListBenchmark.nativeArrayConstructor(array)
      },
      empty () {
        return ListBenchmark.emptyConstructor
      }
    },
    conversions: {
      nativeArray (me) {
        return ListBenchmark.nativeArrayConversion(me)
      }
    },
    modifications: {
      push (me, item) {
        return ListBenchmark.pushModification(me)(item)
      },
      pop (me) {
        return ListBenchmark.popModification(me)
      },
      unshift (me, item) {
        return ListBenchmark.unshiftModification(item)(me)
      },
      shift (me) {
        return ListBenchmark.shiftModification(me)
      },
      concat (me, other) {
        return ListBenchmark.concatModification(me)(other)
      }
    },
    searches: {
      get (me, index) {
        return ListBenchmark.getSearch(me)(index)
      }
    },
    comparisons: {
      equals (me, other) {
        return ListBenchmark.equalsComparison(me)(other)
      }
    }
  }
}
